tbb::flow::interface11::write_once_node< T > Class Template Reference

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::write_once_node< T >:
Collaboration diagram for tbb::flow::interface11::write_once_node< T >:

## Public Types

typedef T | input_type
typedef T | output_type
typedef overwrite_node< T > | base_type
typedef receiver< input_type >::predecessor_type | predecessor_type
typedef sender< output_type >::successor_type | successor_type
Public Types inherited from tbb::flow::interface11::overwrite_node< T >
typedef T | input_type
typedef T | output_type
typedef receiver< input_type >::predecessor_type | predecessor_type
typedef sender< output_type >::successor_type | successor_type
Public Types inherited from tbb::flow::interface11::internal::untyped_receiver
typedef untyped_sender | predecessor_type
| The predecessor type for this node. More...
Public Types inherited from tbb::flow::interface11::internal::untyped_sender
typedef untyped_receiver | successor_type
| The successor type for this node. More...

## Public Member Functions

__TBB_NOINLINE_SYM | write_once_node (graph &g)
| Constructor. More...
__TBB_NOINLINE_SYM | write_once_node (const write_once_node &src)
| Copy constructor: call base class copy constructor. More...
Public Member Functions inherited from tbb::flow::interface11::overwrite_node< T >
__TBB_NOINLINE_SYM | overwrite_node (graph &g)
__TBB_NOINLINE_SYM | overwrite_node (const overwrite_node &src)
| Copy constructor; doesn't take anything from src; default won't work. More...
| ~overwrite_node ()
bool | register_successor (successor_type &s) __TBB_override
| Add a new successor to this node. More...
bool | remove_successor (successor_type &s) __TBB_override
| Removes a successor from this node. More...
bool | try_get (input_type &v) __TBB_override
| Request an item from the sender. More...
bool | try_reserve (T &v) __TBB_override
| Reserves an item. More...
bool | try_release () __TBB_override
| Releases the reserved item. More...
bool | try_consume () __TBB_override
| Consumes the reserved item. More...
bool | is_valid ()
void | clear ()
Public Member Functions inherited from tbb::flow::interface11::graph_node
| graph_node (graph &g)
virtual | ~graph_node ()
Public Member Functions inherited from tbb::flow::interface11::receiver< T >
bool | try_put (const typename internal::async_helpers< T >::filtered_type &t)
| Put an item to the receiver. More...
bool | try_put (const typename internal::async_helpers< T >::async_type &t)
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
virtual | ~untyped_receiver ()
| Destructor. More...
template<typename X >
bool | try_put (const X &t)
| Put an item to the receiver. More...
virtual bool | register_predecessor (predecessor_type &)
| Add a predecessor to the node. More...
virtual bool | remove_predecessor (predecessor_type &)
| Remove a predecessor from the node. More...
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
virtual | ~untyped_sender ()

## Protected Member Functions

task * | try_put_task (const T &v) __TBB_override
| Put item to successor; return task to run the successor if possible. More...
Protected Member Functions inherited from tbb::flow::interface11::overwrite_node< T >
task * | try_put_task_impl (const input_type &v)
graph & | graph_reference () const __TBB_override
void | reset_receiver (reset_flags) __TBB_override
| put receiver back in initial state More...
void | reset_node (reset_flags f) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::receiver< T >
virtual task * | try_put_task_wrapper (const void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
template<typename X >
task * | try_put_task (const X &t)
virtual bool | is_continue_receiver ()
Protected Member Functions inherited from tbb::flow::interface11::sender< T >
virtual bool | try_get_wrapper (void *p, bool is_async) __TBB_override
virtual bool | try_reserve_wrapper (void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
template<typename X >
bool | try_get (X &t)
| Request an item from the sender. More...
template<typename X >
bool | try_reserve (X &t)
| Reserves an item in the sender. More...

## Friends

template<typename R , typename B >
class | run_and_put_task
template<typename X , typename Y >
class | internal::broadcast_cache
template<typename X , typename Y >
class | internal::round_robin_cache

## Additional Inherited Members

Public Attributes inherited from tbb::flow::interface11::receiver< T >
__TBB_DEPRECATED typedef T | input_type
| The input type of this receiver. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type
Public Attributes inherited from tbb::flow::interface11::sender< T >
__TBB_DEPRECATED typedef T | output_type
| The output type of this sender. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type
Protected Attributes inherited from tbb::flow::interface11::overwrite_node< T >
spin_mutex | my_mutex
internal::broadcast_cache< input_type, null_rw_mutex > | my_successors
input_type | my_buffer
bool | my_buffer_is_valid
Protected Attributes inherited from tbb::flow::interface11::graph_node
graph & | my_graph
graph_node * | next
graph_node * | prev

## Detailed Description

### template<typename T>
class tbb::flow::interface11::write_once_node< T >

Definition at line 4622 of file flow_graph.h.

## Member Typedef Documentation

## base_type

template<typename T >

typedef overwrite_node<T> tbb::flow::interface11::write_once_node< T >::base_type

Definition at line 4626 of file flow_graph.h.

## input_type

template<typename T >

typedef T tbb::flow::interface11::write_once_node< T >::input_type

Definition at line 4624 of file flow_graph.h.

## output_type

template<typename T >

typedef T tbb::flow::interface11::write_once_node< T >::output_type

Definition at line 4625 of file flow_graph.h.

## predecessor_type

template<typename T >

typedef receiver<input_type>::predecessor_type tbb::flow::interface11::write_once_node< T >::predecessor_type

Definition at line 4627 of file flow_graph.h.

## successor_type

template<typename T >

typedef sender<output_type>::successor_type tbb::flow::interface11::write_once_node< T >::successor_type

Definition at line 4628 of file flow_graph.h.

## Constructor & Destructor Documentation

## write_once_node() [1/2]

template<typename T >

__TBB_NOINLINE_SYM tbb::flow::interface11::write_once_node< T >::write_once_node | ( | graph & | g | ) |

inline explicit

Constructor.

Definition at line 4631 of file flow_graph.h.

: base_type(g) {
tbb::internal::fgt_node( CODEPTR(), tbb::internal::FLOW_WRITE_ONCE_NODE, &(this->my_graph),
static_cast<receiver<input_type> *>(this),
static_cast<sender<output_type> *>(this) );
}
CODEPTR
#define CODEPTR()
Definition: _flow_graph_trace_impl.h:297
tbb::internal::fgt_node
static void fgt_node(void *, string_index, void *, void *)
Definition: _flow_graph_trace_impl.h:326
tbb::flow::interface11::write_once_node::base_type
overwrite_node< T > base_type
Definition: flow_graph.h:4626
tbb::flow::interface11::graph_node::my_graph
graph & my_graph
Definition: _flow_graph_impl.h:464

References CODEPTR, and tbb::internal::fgt_node().

Here is the call graph for this function:

## write_once_node() [2/2]

template<typename T >

__TBB_NOINLINE_SYM tbb::flow::interface11::write_once_node< T >::write_once_node | ( | const write_once_node< T > & | src | ) |

inline

Copy constructor: call base class copy constructor.

Definition at line 4645 of file flow_graph.h.

: base_type(src) {
tbb::internal::fgt_node( CODEPTR(), tbb::internal::FLOW_WRITE_ONCE_NODE, &(this->my_graph),
static_cast<receiver<input_type> *>(this),
static_cast<sender<output_type> *>(this) );
}

References CODEPTR, and tbb::internal::fgt_node().

Here is the call graph for this function:

## Member Function Documentation

## try_put_task()

template<typename T >

task* tbb::flow::interface11::write_once_node< T >::try_put_task | ( | const T & | t | ) |

inline protected virtual

Put item to successor; return task to run the successor if possible.

Reimplemented from tbb::flow::interface11::overwrite_node< T >.

Definition at line 4661 of file flow_graph.h.

{
spin_mutex::scoped_lock l( this->my_mutex );
return this->my_buffer_is_valid ? NULL : this->try_put_task_impl(v);
}
tbb::flow::interface11::overwrite_node::try_put_task_impl
task * try_put_task_impl(const input_type &v)
Definition: flow_graph.h:4575
tbb::flow::interface11::overwrite_node::my_mutex
spin_mutex my_mutex
Definition: flow_graph.h:4604
tbb::flow::interface11::overwrite_node::my_buffer_is_valid
bool my_buffer_is_valid
Definition: flow_graph.h:4610
tbb::spin_mutex::scoped_lock
friend class scoped_lock
Definition: spin_mutex.h:179

## Friends And Related Function Documentation

## internal::broadcast_cache

template<typename T >
template<typename X , typename Y >

friend class internal::broadcast_cache

friend

Definition at line 4659 of file flow_graph.h.

## internal::round_robin_cache

template<typename T >
template<typename X , typename Y >

friend class internal::round_robin_cache

friend

Definition at line 4660 of file flow_graph.h.

## run_and_put_task

template<typename T >
template<typename R , typename B >

friend class run_and_put_task

friend

Definition at line 4658 of file flow_graph.h.

The documentation for this class was generated from the following file:

- flow_graph.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.